package es.dalocar.software;

// Generated 03-may-2010 22:59:56 by Hibernate Tools 3.2.4.GA

import java.util.List;
import javax.naming.InitialContext;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.SessionFactory;
import static org.hibernate.criterion.Example.create;

/**
 * Home object for domain model class Lineaamortizacion.
 * @see es.dalocar.software.Lineaamortizacion
 * @author Hibernate Tools
 */
public class LineaamortizacionHome {

	private static final Log log = LogFactory
			.getLog(LineaamortizacionHome.class);

	private final SessionFactory sessionFactory = getSessionFactory();

	protected SessionFactory getSessionFactory() {
		try {
			return (SessionFactory) new InitialContext()
					.lookup("SessionFactory");
		} catch (Exception e) {
			log.error("Could not locate SessionFactory in JNDI", e);
			throw new IllegalStateException(
					"Could not locate SessionFactory in JNDI");
		}
	}

	public void persist(Lineaamortizacion transientInstance) {
		log.debug("persisting Lineaamortizacion instance");
		try {
			sessionFactory.getCurrentSession().persist(transientInstance);
			log.debug("persist successful");
		} catch (RuntimeException re) {
			log.error("persist failed", re);
			throw re;
		}
	}

	public void attachDirty(Lineaamortizacion instance) {
		log.debug("attaching dirty Lineaamortizacion instance");
		try {
			sessionFactory.getCurrentSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(Lineaamortizacion instance) {
		log.debug("attaching clean Lineaamortizacion instance");
		try {
			sessionFactory.getCurrentSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void delete(Lineaamortizacion persistentInstance) {
		log.debug("deleting Lineaamortizacion instance");
		try {
			sessionFactory.getCurrentSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Lineaamortizacion merge(Lineaamortizacion detachedInstance) {
		log.debug("merging Lineaamortizacion instance");
		try {
			Lineaamortizacion result = (Lineaamortizacion) sessionFactory
					.getCurrentSession().merge(detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public Lineaamortizacion findById(es.dalocar.software.LineaamortizacionId id) {
		log.debug("getting Lineaamortizacion instance with id: " + id);
		try {
			Lineaamortizacion instance = (Lineaamortizacion) sessionFactory
					.getCurrentSession().get(
							"es.dalocar.software.Lineaamortizacion", id);
			if (instance == null) {
				log.debug("get successful, no instance found");
			} else {
				log.debug("get successful, instance found");
			}
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List<Lineaamortizacion> findByExample(Lineaamortizacion instance) {
		log.debug("finding Lineaamortizacion instance by example");
		try {
			List<Lineaamortizacion> results = (List<Lineaamortizacion>) sessionFactory
					.getCurrentSession().createCriteria(
							"es.dalocar.software.Lineaamortizacion").add(
							create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}
}
